diff --git a/misc/arpd.c b/misc/arpd.c
index 504961cb5e3a..1ef837c61581 100644
--- a/misc/arpd.c
+++ b/misc/arpd.c
@@ -1,11 +1,7 @@
+/* SPDX-License-Identifier: GPL-2.0-or-later */
 /*
  * arpd.c	ARP helper daemon.
  *
- *		This program is free software; you can redistribute it and/or
- *		modify it under the terms of the GNU General Public License
- *		as published by the Free Software Foundation; either version
- *		2 of the License, or (at your option) any later version.
- *
  * Authors:	Alexey Kuznetsov, <kuznet@ms2.inr.ac.ru>
  */
 
diff --git a/misc/ifstat.c b/misc/ifstat.c
index 291f288b3752..4ce5ca8af4e7 100644
--- a/misc/ifstat.c
+++ b/misc/ifstat.c
@@ -1,11 +1,7 @@
+/* SPDX-License-Identifier: GPL-2.0-or-later */
 /*
  * ifstat.c	handy utility to read net interface statistics
  *
- *		This program is free software; you can redistribute it and/or
- *		modify it under the terms of the GNU General Public License
- *		as published by the Free Software Foundation; either version
- *		2 of the License, or (at your option) any later version.
- *
  * Authors:	Alexey Kuznetsov, <kuznet@ms2.inr.ac.ru>
  */
 
diff --git a/misc/lnstat.c b/misc/lnstat.c
index c3293a8eb12f..c3f2999cc255 100644
--- a/misc/lnstat.c
+++ b/misc/lnstat.c
@@ -1,3 +1,4 @@
+/* SPDX-License-Identifier: GPL-2.0-or-later */
 /* lnstat - Unified linux network statistics
  *
  * Copyright (C) 2004 by Harald Welte <laforge@gnumonks.org>
@@ -8,12 +9,6 @@
  *
  * Copyright 2001 by Robert Olsson <robert.olsson@its.uu.se>
  *                                 Uppsala University, Sweden
- *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License as published by
- * the Free Software Foundation; either version 2 of the License, or
- * (at your option) any later version.
- *
  */
 
 /* Maximum number of fields that can be displayed */
diff --git a/misc/lnstat_util.c b/misc/lnstat_util.c
index c2dc42ec1ff1..3f53e91afbf8 100644
--- a/misc/lnstat_util.c
+++ b/misc/lnstat_util.c
@@ -1,3 +1,4 @@
+/* SPDX-License-Identifier: GPL-2.0-or-later */
 /* lnstat.c:  Unified linux network statistics
  *
  * Copyright (C) 2004 by Harald Welte <laforge@gnumonks.org>
@@ -8,12 +9,6 @@
  *
  * Copyright 2001 by Robert Olsson <robert.olsson@its.uu.se>
  *                                 Uppsala University, Sweden
- *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License as published by
- * the Free Software Foundation; either version 2 of the License, or
- * (at your option) any later version.
- *
  */
 
 #include <unistd.h>
diff --git a/misc/nstat.c b/misc/nstat.c
index 7160c59be222..0ab92ecbeb47 100644
--- a/misc/nstat.c
+++ b/misc/nstat.c
@@ -1,11 +1,7 @@
+/* SPDX-License-Identifier: GPL-2.0-or-later */
 /*
  * nstat.c	handy utility to read counters /proc/net/netstat and snmp
  *
- *		This program is free software; you can redistribute it and/or
- *		modify it under the terms of the GNU General Public License
- *		as published by the Free Software Foundation; either version
- *		2 of the License, or (at your option) any later version.
- *
  * Authors:	Alexey Kuznetsov, <kuznet@ms2.inr.ac.ru>
  */
 
diff --git a/misc/rtacct.c b/misc/rtacct.c
index 47b27e3fd88d..08363bfd4f26 100644
--- a/misc/rtacct.c
+++ b/misc/rtacct.c
@@ -1,13 +1,8 @@
+/* SPDX-License-Identifier: GPL-2.0-or-later */
 /*
  * rtacct.c		Applet to display contents of /proc/net/rt_acct.
  *
- *		This program is free software; you can redistribute it and/or
- *		modify it under the terms of the GNU General Public License
- *		as published by the Free Software Foundation; either version
- *		2 of the License, or (at your option) any later version.
- *
  * Authors:	Alexey Kuznetsov, <kuznet@ms2.inr.ac.ru>
- *
  */
 
 #include <stdio.h>
diff --git a/misc/ss.c b/misc/ss.c
index ccfa9fa9ef8e..de02fccb539b 100644
--- a/misc/ss.c
+++ b/misc/ss.c
@@ -1,11 +1,7 @@
+/* SPDX-License-Identifier: GPL-2.0-or-later */
 /*
  * ss.c		"sockstat", socket statistics
  *
- *		This program is free software; you can redistribute it and/or
- *		modify it under the terms of the GNU General Public License
- *		as published by the Free Software Foundation; either version
- *		2 of the License, or (at your option) any later version.
- *
  * Authors:	Alexey Kuznetsov, <kuznet@ms2.inr.ac.ru>
  */
 
diff --git a/misc/ss_util.h b/misc/ss_util.h
index f7e40bb9b93c..37936c6623ea 100644
--- a/misc/ss_util.h
+++ b/misc/ss_util.h
@@ -1,3 +1,4 @@
+/* SPDX-License-Identifier: GPL-2.0-or-later */
 #ifndef __SS_UTIL_H__
 #define __SS_UTIL_H__
 
diff --git a/misc/ssfilter.h b/misc/ssfilter.h
index 0be3b1e03b9f..73e55e042b6b 100644
--- a/misc/ssfilter.h
+++ b/misc/ssfilter.h
@@ -1,3 +1,4 @@
+/* SPDX-License-Identifier: GPL-2.0-or-later */
 #include <stdbool.h>
 
 enum {
diff --git a/misc/ssfilter.y b/misc/ssfilter.y
index 8e16b44638f6..3195723b2277 100644
--- a/misc/ssfilter.y
+++ b/misc/ssfilter.y
@@ -1,4 +1,5 @@
 %{
+/* SPDX-License-Identifier: GPL-2.0-or-later */
 
 #include <stdio.h>
 #include <stdlib.h>
diff --git a/misc/ssfilter_check.c b/misc/ssfilter_check.c
index 38c960c1bc91..a188bb346999 100644
--- a/misc/ssfilter_check.c
+++ b/misc/ssfilter_check.c
@@ -1,3 +1,4 @@
+/* SPDX-License-Identifier: GPL-2.0-or-later */
 #include <stdio.h>
 #include <stdlib.h>
 #include <errno.h>